Index: branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc
===================================================================
--- branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc	(revision 10199)
+++ branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc	(revision 10200)
@@ -21,4 +21,5 @@
 #include <iostream>
 #include "math.h"
+#include "glgui_image.h"
 
 namespace OrxGui
@@ -43,17 +44,33 @@
 
     this->_image.setParent2D(this);
-    this->_image.setSize2D(20,20);
-    this->_image.setBackgroundColor(Color(1,1,1,.8));
-    this->_image.setBackgroundTexture("maps/TE2.png");
-    this->_image.setRelCoor2D(borderLeft(), borderTop() + this->_bar.getSizeX2D());
+    this->_image.setBorderTop(0);
+    this->_image.setBorderLeft(0);
+    this->_image.setBorderRight(0);
+    this->_image.setBorderBottom(0);
+    this->_image.setWidgetSize(30,30);
+    this->_image.setForegroundColor(Color(1,1,1,0.6));
+    this->_image.setBackgroundColor(Color(1,1,1,0));
+    this->_image.setBackgroundTexture(Texture());
+    this->_image.loadImageFromFile("maps/evil-flower.png");
+    //this->_image.setRelCoor2D(borderLeft(), borderTop() + this->_bar.getSizeX2D());
+    this->_image.setRelCoor2D(0,0);
+    this->_image.setRelDir2D(90);
+    this->_image.setVisibility(true);
 
     this->_valueText.setParent2D(this);
-    this->_valueText.setSize2D(100,20);
-    this->_valueText.setRelCoor2D(borderLeft(), borderTop() + this->_bar.getSizeX2D());
+    this->_valueText.setWidgetSize(100,20);
+    //this->_valueText.setRelCoor2D(borderLeft(), borderTop() + this->_bar.getSizeX2D());
+    this->_valueText.setRelCoor2D(0,0);
     this->_valueText.setChangedTextColor(Color::white);
 
     this->setBackgroundTexture(Texture());
-    this->setBackgroundColor(Color(.5,.5,.5,0));
-    this->setSize2D(120,20);
+    this->setBackgroundColor(Color(1,1,1,0.5));
+    this->setBorderTop(10);
+    this->setBorderLeft(10);
+    this->setBorderRight(10);
+    this->setBorderBottom(10);
+    this->setWidgetSize(120,50);
+    this->setVisibility(true);
+    
 
     //this->_name.setBackgroundTexture(Texture());
@@ -66,6 +83,11 @@
     this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
     this->_bar.setChangedValueColor(Color::black);
-    this->_bar.setSize2D(100,20);
-    this->_bar.setRelCoor2D(borderLeft(), 0);
+    this->_bar.setBorderTop(0);
+    this->_bar.setBorderLeft(0);
+    this->_bar.setBorderRight(0);
+    this->_bar.setBorderBottom(0);
+    this->_bar.setWidgetSize(100,30);
+    //this->_bar.setRelCoor2D(borderLeft(), 0);
+    this->_bar.setRelCoor2D(0,0);
   }
 
@@ -86,4 +108,5 @@
   {
     MultiType val(value);
+    //MultiType val(200.00);
     val.setType(MT_INT);
 
@@ -94,4 +117,9 @@
     this->_valueText.setText(val.getString());
     //this->_valueText.setText("asdfas");
+  }
+
+  void GLGuiEnergyWidgetVertical::setDisplayedImage(const std::string& imageName)
+  {
+    this->_image.loadImageFromFile(imageName);
   }
 
@@ -107,4 +135,5 @@
     this->_valueText.show();
     this->_bar.show();
+    //this->show();
   }
 
Index: branches/playability/src/world_entities/elements/glgui_energywidgetvertical.h
===================================================================
--- branches/playability/src/world_entities/elements/glgui_energywidgetvertical.h	(revision 10199)
+++ branches/playability/src/world_entities/elements/glgui_energywidgetvertical.h	(revision 10200)
@@ -7,8 +7,8 @@
 #define _GLGUI_ENERGY_WIDGET_VERTICAL_H
 
-#include "glgui_box.h"
+//#include "glgui_box.h"
 #include "glgui_bar.h"
 #include "glgui_text.h"
-#include "glgui_widget.h"
+#include "glgui_image.h"
 
 namespace OrxGui
@@ -25,4 +25,5 @@
     void setMaximum(float max);
     void setValue(float value);
+    void setDisplayedImage(const std::string& imageName);
 
     inline GLGuiWidget* getImageWidget() {return &this->_image;};
@@ -36,5 +37,5 @@
 
   private:
-    GLGuiWidget             _image;
+    GLGuiImage             _image;
     GLGuiText               _valueText;
     GLGuiBar                _bar;