Index: /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.cc
===================================================================
--- /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10210)
+++ /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10211)
@@ -316,25 +316,4 @@
     /**
     @brief
-        Looks for an attached Engine with a certain name.
-    @param name
-        The name of the engine to be returned.
-    @return
-        Pointer to the engine with the given name, or NULL if not found.
-    */
-    Engine* ModularSpaceShip::getEngineByName(std::string name)
-    {
-        for(std::vector<Engine*>::iterator it = this->engineList_.begin(); it != this->engineList_.end(); ++it)
-        {
-            if(orxonox_cast<Engine*>(*it)->getName() == name)
-            {
-                return orxonox_cast<Engine*>(*it);
-            }
-        }
-        orxout(internal_warning) << "Couldn't find Engine with name \"" << name << "\"." << endl;
-        return NULL;
-    }
-
-    /**
-    @brief
         Detaches a child WorldEntity from this instance.
     */
Index: /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.h
===================================================================
--- /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10210)
+++ /code/branches/presentationFS14/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10211)
@@ -127,5 +127,4 @@
                 { return this->rotationThrust_; }
 
-            Engine* getEngineByName(std::string name);
             void detach(WorldEntity* object);
 
Index: /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.cc
===================================================================
--- /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 10210)
+++ /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 10211)
@@ -342,4 +342,22 @@
     /**
     @brief
+        Looks for an attached Engine with a certain name.
+    @param name
+        The name of the engine to be returned.
+    @return
+        Pointer to the engine with the given name, or NULL if not found.
+    */
+    Engine* SpaceShip::getEngineByName(const std::string& name)
+    {
+        for(size_t i = 0; i < this->engineList_.size(); ++i)
+            if(this->engineList_[i]->getName() == name)
+                return this->engineList_[i];
+
+        orxout(internal_warning) << "Couldn't find Engine with name \"" << name << "\"." << endl;
+        return NULL;
+    }
+
+    /**
+    @brief
         Remove and destroy all Engines of the SpaceShip.
     */
Index: /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.h
===================================================================
--- /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 10210)
+++ /code/branches/presentationFS14/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 10211)
@@ -124,4 +124,5 @@
             bool hasEngine(Engine* engine) const; // Check whether the SpaceShip has a particular Engine.
             Engine* getEngine(unsigned int i); // Get the i-th Engine of the SpaceShip.
+            Engine* getEngineByName(const std::string& name);
             /**
             @brief Get the list of all Engines that are mounted on the SpaceShip.
@@ -270,6 +271,4 @@
             float stallSpeed_; //!< The forward speed where no more lift is added.
 
-            std::vector<Engine*> engineList_; //!< The list of all Engines mounted on this SpaceShip.
-
         private:
             void registerVariables();
@@ -286,4 +285,6 @@
             void backupCamera(); // Save the original position and orientation of the camera.
             void resetCamera(); // Reset the camera to its original position.
+
+            std::vector<Engine*> engineList_; //!< The list of all Engines mounted on this SpaceShip.
 
             Timer timer_;                          //!< Timer for the cooldown duration.