Index: branches/playability/src/util/hud.cc
===================================================================
--- branches/playability/src/util/hud.cc	(revision 10232)
+++ branches/playability/src/util/hud.cc	(revision 10233)
@@ -57,5 +57,8 @@
   this->resY = 1;
 
-  this->travelZoneWidth = 0.7;
+  this->overlayPercentage = 5;
+  this->overlayActive = false;
+  this->rightRect = NULL;
+  this->leftRect = NULL;
 
   this->inputLine = new OrxGui::GLGuiInputLine();
@@ -83,4 +86,6 @@
 
   delete this->_radar;
+  delete this->rightRect;
+  delete this->leftRect;
   //if (this->shipValuesBox != NULL)
     //delete this->shipValuesBox;
@@ -286,4 +291,33 @@
   this->notifier->setWidgetSize(0.25 * this->resX, 0.6 * this->resY);
 
+  if (this->overlayActive == true)
+  {
+    if (this->rightRect == NULL)
+      this->rightRect = new OrxGui::GLGuiWidget();
+    //if (this->leftRect == NULL)
+      //this->leftRect = new OrxGui::GLGuiWidget();
+    
+    int overlayWidth = this->resX * (100-overlayPercentage)/(200);
+    this->rightRect->hide();
+    /*
+    this->leftRect->setWidgetSize(float(overlayWidth), float(this->resY));
+    this->leftRect->setAbsCoor2D(0,0);
+    this->leftRect->setBackgroundTexture(Texture());
+    this->leftRect->setBackgroundColor(Color(0,0,0.7,0.2));
+    this->leftRect->show();
+    */
+    
+    
+    this->rightRect->setParent2D(this);
+    this->rightRect->setWidgetSize(float(overlayWidth), float(this->resY));
+    this->rightRect->setAbsCoor2D(this->resX - overlayWidth,this->resY);
+    this->rightRect->setBackgroundTexture(Texture());
+    this->rightRect->setBackgroundColor(Color(0,0,0.7,0.2));
+    //this->rightRect->setForegroundTexture(Texture());
+    //this->rightRect->setForegroundColor(Color(1,1,1,1));
+    this->rightRect->show();
+    
+  }
+
 
   if (State::getPlayer() && State::getPlayer()->getPlayable() && State::getObjectManager())
@@ -349,6 +383,4 @@
   }
 
-  //if (this->rightRect == NULL)
-         
 }
 
Index: branches/playability/src/util/hud.h
===================================================================
--- branches/playability/src/util/hud.h	(revision 10232)
+++ branches/playability/src/util/hud.h	(revision 10233)
@@ -54,10 +54,17 @@
   void updateWeaponManager();
 
-  inline void setTravelZoneWidth(float width) 
+  inline void setOverlayPercentage(int perc) 
   {
-    if (width > 1) width = 1;
-    else if (width < 0) width = 0;
+    if (perc > 100) perc = 100;
+    else if (perc < 0) perc = 0;
 
-    this->travelZoneWidth = width;
+    this->overlayPercentage = perc;
+    updateResolution();
+  };
+
+  inline void setOverlayActive(bool b)
+  {
+    overlayActive = b;
+    updateResolution();
   };
 
@@ -84,5 +91,8 @@
   OrxGui::GLGuiRadar*      _radar;
 
-  OrxGui::GLGuiWidget*     rightRect, leftRect;
+  OrxGui::GLGuiWidget*     rightRect;
+  OrxGui::GLGuiWidget*     leftRect;
+  bool                     overlayActive;
+  int                      overlayPercentage; //the percentage of the screen, the player has got for his movements. should always be a value between 0 and 1;
 
   WeaponManager*           weaponManager;
Index: branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc
===================================================================
--- branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc	(revision 10232)
+++ branches/playability/src/world_entities/elements/glgui_energywidgetvertical.cc	(revision 10233)
@@ -54,5 +54,5 @@
     this->_bar.setValue(value);
     this->_bar.setForegroundColor(Color::slerpHSVColor(Color::red, Color::green, value/this->_bar.maximum()));
-    this->_bar.setFrontColor(Color(1,1,1,1), true);
+    //this->_bar.setFrontColor(Color(1,1,1,1), true);
     this->_valueText.setText(val.getString());
     //this->_valueText.setText("asdfas");
Index: branches/playability/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10232)
+++ branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10233)
@@ -424,4 +424,5 @@
   this->secWeaponMan.showCrosshair();
   this->toList( OM_GROUP_01 );
+  State::getPlayer()->hud().setOverlayActive(true);
   //dynamic_cast <OrxGui::GLGuiEnergyWidgetVertical*> (State::getPlayer()->hud().getArmorWidget())->setDisplayedName("Armor");
   //dynamic_cast<Element2D*>(this->secWeaponMan.getFixedTarget())->setVisibility( true);
@@ -434,4 +435,5 @@
   this->secWeaponMan.hideCrosshair();
   this->toList( OM_GROUP_00);
+  State::getPlayer()->hud().setOverlayActive(false);
   //dynamic_cast<Element2D*>(this->secWeaponMan.getFixedTarget())->setVisibility( false);
   //this->detachCamera();