Index: branches/playability/src/world_entities/projectiles/hbolt.cc
===================================================================
--- branches/playability/src/world_entities/projectiles/hbolt.cc	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/hbolt.cc	(revision 10274)
@@ -45,5 +45,5 @@
   this->setMinEnergy(10);
   this->setHealthMax(0);
-  this->lifeSpan = 7.0;
+  this->lifeSpan = 2.0;
 
   this->angle = 0;
@@ -84,4 +84,5 @@
 void HBolt::activate()
 {
+  this->toList(OM_ENVIRON);
   if (unlikely(HBolt::explosionParticles == NULL))
   {
@@ -108,11 +109,12 @@
   this->lifeCycle = 0.0;
 
-  this->toList(OM_NULL);
+  this->toList(OM_DEAD);
   this->removeNode();
   HBolt::fastFactory->kill(this);
+
 }
 
 
-void HBolt::hit (WorldEntity* entity, float damage)
+void HBolt::hit (float damage, WorldEntity* entity )
 {
   printf("Collision with HBolt\n");
@@ -140,5 +142,13 @@
   this->angle += this->rotationSpeed * dt;
 
-
+  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() == OM_GROUP_00)  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
+    {
+      (*eIterator)->hit (this->getDamage(),this);
+      this->deactivate();
+  PRINTF(0)("HBolt destroyed\n");
+    }
+  }
 }
 
Index: branches/playability/src/world_entities/projectiles/hbolt.h
===================================================================
--- branches/playability/src/world_entities/projectiles/hbolt.h	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/hbolt.h	(revision 10274)
@@ -27,5 +27,5 @@
     virtual void deactivate();
 
-    virtual void hit (WorldEntity* entity, float damage);
+    virtual void hit (float damage, WorldEntity* entity);
 
     virtual void destroy (WorldEntity* killer);
Index: branches/playability/src/world_entities/projectiles/lbolt.cc
===================================================================
--- branches/playability/src/world_entities/projectiles/lbolt.cc	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/lbolt.cc	(revision 10274)
@@ -47,5 +47,5 @@
   this->setMinEnergy(1);
   this->setHealthMax(0);
-  this->lifeSpan = 2.0;
+  this->lifeSpan = 1.0;
 
   this->emitter = new DotEmitter(100, 5, M_2_PI);
@@ -86,4 +86,5 @@
 void LBolt::activate()
 {
+  this->toList(OM_ENVIRON);
   if (unlikely(LBolt::explosionParticles == NULL))
   {
@@ -110,5 +111,5 @@
   this->lifeCycle = 0.0;
 
-  this->toList(OM_NULL);
+  this->toList(OM_DEAD);
   this->removeNode();
   LBolt::fastFactory->kill(this);
@@ -116,5 +117,5 @@
 
 
-void LBolt::hit (WorldEntity* entity, float damage)
+void LBolt::hit (float damage, WorldEntity* entity )
 {
   PRINTF(0)("Collision with LBolt\n");
@@ -139,4 +140,14 @@
 
   angle += rotationSpeed * dt;
+
+  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() == OM_GROUP_00)  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
+    {
+      (*eIterator)->hit (this->getDamage(),this);
+      this->deactivate();
+  PRINTF(0)("LBolt destroyed\n");
+    }
+  }
 }
 
Index: branches/playability/src/world_entities/projectiles/lbolt.h
===================================================================
--- branches/playability/src/world_entities/projectiles/lbolt.h	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/lbolt.h	(revision 10274)
@@ -27,5 +27,5 @@
     virtual void deactivate();
 
-    virtual void hit (WorldEntity* entity, float damage);
+    virtual void hit (float damage, WorldEntity* entity);
 
     virtual void destroy (WorldEntity* killer);
Index: branches/playability/src/world_entities/projectiles/mbolt.cc
===================================================================
--- branches/playability/src/world_entities/projectiles/mbolt.cc	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/mbolt.cc	(revision 10274)
@@ -53,5 +53,5 @@
   this->setMinEnergy(4);
   this->setHealthMax(0);
-  this->lifeSpan = 3.0;
+  this->lifeSpan = 1.5;
   this->angle     = 0;
 
@@ -107,4 +107,5 @@
 void MBolt::activate()
 {
+  this->toList(OM_ENVIRON);
   if (unlikely(MBolt::explosionParticles == NULL))
   {
@@ -141,5 +142,5 @@
 }
 
-void MBolt::hit (WorldEntity* entity, float damage)
+void MBolt::hit (float damage, WorldEntity* entity )
 {
 
@@ -170,4 +171,14 @@
   this->angle += MBolt::rotationSpeed * dt;
   this->trail->tick(dt);
+
+  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() == OM_GROUP_00) && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
+    {
+      (*eIterator)->hit (this->getDamage(),this);
+      this->deactivate();
+      PRINTF(0)("MBolt destroyed\n");
+    }
+  }
 }
 
Index: branches/playability/src/world_entities/projectiles/mbolt.h
===================================================================
--- branches/playability/src/world_entities/projectiles/mbolt.h	(revision 10273)
+++ branches/playability/src/world_entities/projectiles/mbolt.h	(revision 10274)
@@ -28,5 +28,5 @@
     virtual void deactivate();
 
-    virtual void hit (WorldEntity* entity, float damage);
+    virtual void hit (float damage, WorldEntity* entity);
 
     virtual void destroy (WorldEntity* killer);
Index: branches/playability/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10273)
+++ branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10274)
@@ -1040,5 +1040,5 @@
 }
 
-void SpaceShip::hit(float damage, WorldEntity* killer)
+void SpaceShip::hit( float damage, WorldEntity* killer)
 {
   this->damage(killer->getDamage(),0);
Index: branches/playability/src/world_entities/space_ships/space_ship.h
===================================================================
--- branches/playability/src/world_entities/space_ships/space_ship.h	(revision 10273)
+++ branches/playability/src/world_entities/space_ships/space_ship.h	(revision 10274)
@@ -59,4 +59,5 @@
 
     virtual void process(const Event &event);
+//    virtual void hit (WorldEntity* entity, float damage);
 
     inline WeaponManager& getWeaponManagerSecondary() { return this->secWeaponMan; };
@@ -204,5 +205,4 @@
     Trail*                trailR;              //!< Burst trail
 
-//    Wobblegrid*           test;
 
 };